000001 IDENTIFICATION  DIVISION.
000002* CALLK32-MAINFORM.
000003 PROGRAM-ID.     CALLK32-MAINFORM.
000004 ENVIRONMENT     DIVISION.
000005 CONFIGURATION   SECTION.
000006 POW-REPOSITORY.
000007     CLASS  AMETHODSETCALLK32-MAINFORM AS "TLB=C:\temp\CallK32\MainModule\Debug\~build.tlb,{79754E82-F63B-11D2-90A0-005004242C85},FUJITSU-PCOBFORM-4"
000008     CLASS  AMIXED-DCFGWND-MAIN-WITH-DCFGROUPITEM-MAIN AS "TLB=C:\temp\CallK32\MainModule\Debug\~build.tlb,{F06C8458-672C-11D2-81F0-00A0C9613687},FUJITSU-PCOBFORMWND-4"
000009 .
000010 SPECIAL-NAMES.
000011 REPOSITORY.
000012 .
000013 INPUT-OUTPUT    SECTION.
000014 FILE-CONTROL.
000015 DATA            DIVISION.
000016 BASED-STORAGE   SECTION.
000017 FILE            SECTION.
000018 WORKING-STORAGE SECTION.
000019 CONSTANT        SECTION.
000020 LINKAGE         SECTION.
000021 01  POW-FORM IS GLOBAL.
000022   02  POW-SELF OBJECT REFERENCE AMETHODSETCALLK32-MAINFORM.
000023   02  POW-SUPER  PIC X(4).
000024   02  POW-THIS OBJECT REFERENCE AMETHODSETCALLK32-MAINFORM.
000025 01  CALLK32-MAINFORM REDEFINES POW-FORM GLOBAL OBJECT REFERENCE AMETHODSETCALLK32-MAINFORM.
000026 01  POW-CONTROL-ID PIC S9(9) COMP-5.
000027 01  POW-EVENT-ID   PIC S9(9) COMP-5.
000028 01  POW-OLE-PARAM  PIC X(4).
000029 01  POW-OLE-RETURN PIC X(4).
000030 
000031 PROCEDURE       DIVISION USING POW-FORM POW-CONTROL-ID POW-EVENT-ID POW-OLE-PARAM POW-OLE-RETURN.
000032     EVALUATE POW-CONTROL-ID
000033     WHEN 117440513
000034     EVALUATE POW-EVENT-ID
000035     WHEN 117440768
000036       CALL "POW-SCRIPTLET1"
000037     END-EVALUATE
000038     END-EVALUATE
000039     EXIT PROGRAM.
000040 
000041 IDENTIFICATION  DIVISION.
000042* CallK32-MainForm-Opened.
000043 PROGRAM-ID.     POW-SCRIPTLET1.
000044 ENVIRONMENT DIVISION.
000045 DATA DIVISION.
000046 WORKING-STORAGE SECTION.
000047
000048 *> NOTE: 
000049 *>    The following lines must be included in the COBOL85.CBL file located in the same directory as the
000050 *>    program .EXE file. The 'KER' of [KER.ENTRY] is the name of the form from which the functions are 
000051 *>    called. The '.ENTRY' is a required suffix for this section. If this section is note included the 
000052 *>    program will generate a JMP0015I-U error when run.
000053 *>
000054 *> [CallK32-MainForm.ENTRY]
000055 *> GetCurrentDirectoryA=KERNEL32
000056 *> GetShortPathNameA=KERNEL32
000057 *> GetLastError=KERNEL32
000058
000059 *>  Define variables to hold KERNEL32 function names.
000060 01  GetCurrentDirectoryA	 PIC X(20) VALUE "GetCurrentDirectoryA".
000061 01  GetShortPathNameA	 PIC X(17) VALUE "GetShortPathNameA".
000062 01  GetLastError  	 PIC X(12) VALUE "GetLastError".
000063
000064 *>  Note the following relationships:
000065 *>  PIC S9(9) COMP-5 corresponds to DWORD or LONG INT
000066 *>  PIC X(???) corresponds to a CHAR string
000067 01  PTR                   PIC 999 VALUE ZERO.         *> general counter variable
000068 01  CALL-RESULT           PIC S9(9) COMP-5.           *> holds function return value
000069 01  LONG-DIRECTORY        PIC X(128).                 *> holds long directory name before conversion
000070 01  LONG-DIRECTORY-LENGTH PIC S9(9) COMP-5 VALUE 128. *> DWORD type. Used to pass length of LONG-DIRECTORY
000071 01  SHORT-DIRECTORY       PIC X(64).                  *> holds short directory name after conversion
000072 01  SHORT-DIR-LENGTH      PIC S9(9) COMP-5 VALUE 64.  *> DWORD type. Used to pass length of SHORT-DIRECTORY
000073
000074 PROCEDURE DIVISION.
000075
000076     *> Get current directory. Note essential 'WITH STDCALL LINKAGE' phrase, as well as the use of 'BY VALUE' and 'BY REFERENCE'
000077     CALL GetCurrentDirectoryA WITH STDCALL LINKAGE USING  BY VALUE LONG-DIRECTORY-LENGTH BY REFERENCE LONG-DIRECTORY  RETURNING CALL-RESULT.
000078 
000079     *> Check for a too small buffer.
000080     IF CALL-RESULT >= LONG-DIRECTORY-LENGTH
000081        DISPLAY "LONG-DIRECTORY BUFFER IS TOO SMALL"
000082     END-IF.
000083     
000084     *> Check for an error and return extended error code.
000085     IF CALL-RESULT = ZERO
000086        CALL GetLastError RETURNING CALL-RESULT
000087        DISPLAY "CANNOT READ CURRENT DIRECTORY. ERROR: " CALL-RESULT
000088     END-IF.
000089
000090     *> Convert to short path format. Note the use of 'BY CONTENT' phrase.
000091     CALL GetShortPathNameA WITH STDCALL LINKAGE USING BY CONTENT LONG-DIRECTORY BY REFERENCE SHORT-DIRECTORY BY VALUE SHORT-DIR-LENGTH RETURNING CALL-RESULT. 
000092
000093     *> Check for a too small buffer. 
000094     IF CALL-RESULT = SHORT-DIR-LENGTH
000095        DISPLAY "SHORT-DIRECTORY BUFFER IS TOO SMALL"
000096     END-IF.
000097     
000098     *> Check for an error and return extended error code.
000099     IF CALL-RESULT = ZERO
000100        CALL GetLastError RETURNING CALL-RESULT
000101        DISPLAY "CANNOT CONVERT TO SHORT DIRECTORY. ERROR: " CALL-RESULT
000102     END-IF.
000103
000104     *> Remove all LOW-VALUEs
000105     INSPECT SHORT-DIRECTORY REPLACING ALL LOW-VALUE BY SPACE.
000106     PERFORM VARYING PTR FROM SHORT-DIR-LENGTH BY -1
000107        UNTIL SHORT-DIRECTORY(PTR:1) NOT = SPACE
000108     END-PERFORM.
000109
000110     *> Add an '\' to the end of the pathname (this routine will handle spaces within directory names).
000111     IF PTR < SHORT-DIR-LENGTH
000112        ADD 1 TO PTR
000113        MOVE "\" TO SHORT-DIRECTORY(PTR:1)
000114     END-IF.
000115  
000116     *> Display results so we can see what we have done
000117     INVOKE POW-SELF "DisplayMessage" USING LONG-DIRECTORY "Long Path Name"  POW-DMOK.
000118     INVOKE POW-SELF "DisplayMessage" USING SHORT-DIRECTORY "Short Path Name"  POW-DMOK.
000119     
000120     *> End
000121     INVOKE POW-SELF "Deactivate".
000122 END PROGRAM     POW-SCRIPTLET1.
000123 
000124 END PROGRAM     CALLK32-MAINFORM.
